/* 
 This file was generated by Dashcode.  
 You may edit this file to customize your widget or web page 
 according to the license.txt file included in the project.
 */

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    Prefs.load();
    dashcode.setupParts();
    if(!Prefs.username) {
        showBack();
    } else {
        RefreshContent.startTimer();
    }
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    RefreshContent.stopTimer();
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
    RefreshContent.stopTimer();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    RefreshContent.startTimer();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, dashcode.createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";
    
    RefreshContent.stopTimer();

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";
    
    Prefs.update();
    if(Prefs.username) {
        RefreshContent.startTimer();
    }
    
    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

function sendNewText(event) {
    var params = new Array();
    params[0] = document.getElementById('textfield').value;
    document.getElementById('textfield').value = "";
    result = XMLRPC.call(
        Prefs.server+'/index.php?api=1', 
        "lib.eyeBoard.newMessage", 
        Prefs.username,
        Prefs.password,
        params
    );
    RefreshContent.update();
}

Prefs = {
  username : "",
  password : "",
  server : "",
  
  load : function() {
    Prefs.username = document.getElementById("username").value = widget.preferenceForKey(widget.identifier + "-username") ? widget.preferenceForKey(widget.identifier + "-username") : "";
    Prefs.password = document.getElementById("password").value = widget.preferenceForKey(widget.identifier + "-password") ? widget.preferenceForKey(widget.identifier + "-password") : "";
    Prefs.server = document.getElementById("server").value = widget.preferenceForKey(widget.identifier + "-server") ? widget.preferenceForKey(widget.identifier + "-server") : "http://www.eyeos.info";

  },
  
  update : function() {
    widget.setPreferenceForKey(document.getElementById("username").value, widget.identifier + "-username");
    widget.setPreferenceForKey(document.getElementById("password").value, widget.identifier + "-password");
    widget.setPreferenceForKey(document.getElementById("server").value, widget.identifier + "-server");
    // Sync local variables
    Prefs.load();
  }
};

RefreshContent = {
  timeout : null,
  
  update : function() {
    var params = new Array();
    result = XMLRPC.call(
        Prefs.server+'/index.php?api=1', 
        "lib.eyeBoard.getMessagesHtml", 
        Prefs.username,
        Prefs.password,
        params
    );
    document.getElementById('box').innerHTML = result;
  },
  
  startTimer : function() {
    if(!Prefs.username) {
        return false;
    }
    
    RefreshContent.update();
    RefreshContent.timeout = setTimeout("RefreshContent.startTimer();", 10*1000);
  },
  
  stopTimer : function() {
    clearTimeout(RefreshContent.timeout);
  }
};
